%global             kmod_version 2
%global             latest_kernel 5.14.0-580%{dist}.%{_arch}
%global             latest_kernel_automotive 5.14.0-582.531%{dist}.%{_arch}

%global             srcrev 0289a89e7b6daa708b69ce73d5e4567f79233f3b

%if "%{dist}" == ".el9iv"
%{!?kernel_version:%{expand:%%global kernel_version %{latest_kernel_automotive}}}
%else
%{!?kernel_version:%{expand:%%global kernel_version %{latest_kernel}}}
%endif

Name:               qcom-scmi
%if "%{dist}" == ".el9iv"
Version:            %{lua:print((string.gsub(string.match(rpm.expand("%{kernel_version}"), "(%d+%.%d+%.%d+%-%d+%.%d+%.?[^.]*)%.el9iv"),"-","~")))}.%{kmod_version}
%else
Version:            %{lua:print((string.gsub(string.match(rpm.expand("%{kernel_version}"), "(%d+%.%d+%.%d+%-%d+%.?[^.]*)"..rpm.expand("%{dist}")),"-","~")))}.%{kmod_version}
%endif
Release:            1%{?dist}
Summary:            Qualcomm SCMI compatible kernel modules

License:            GPLv2
URL:                https://gitlab.com/CentOS/automotive/src/kmod-qcom-scmi.git
Source:             https://gitlab.com/CentOS/automotive/src/kmod-qcom-scmi/-/archive/%{srcrev}/kmod-qcom-scmi-%{srcrev}.tar.gz

ExclusiveArch:      aarch64
%global kmodtool_generate_buildreqs 1
%if "%{dist}" == ".el9iv"
BuildRequires:      kernel-automotive-devel-uname-r = %{kernel_version}
%else
BuildRequires:      kernel-devel-uname-r = %{kernel_version}
%endif
BuildRequires:      redhat-rpm-config kernel-rpm-macros elfutils-libelf-devel kmod


%if "%{dist}" == ".el9iv"
%global             compression zstd
%global             compression_flags --rm
%global             compext zst
%else
%global             compression xz
%global             compression_flags --compress
%global             compext xz
%endif


# KMP provides __brp_kmod_compress hook to compress the modules.
# Something is odd with debuginfo. The debugfiles.list is correctly populated
# (*.ko-<nvr>.debug), yet the debuginfo package will not grab the listed debug
# files unless we modify their filenames to have the matching extension.
%define             __brp_kmod_compress \
                        find %{buildroot}/lib/modules -type f -name '*.ko' -exec %{compression} %{compression_flags} {} \\; \
                        while read -r f; do \
                            mv "$f" "${f//\.ko/.ko.%{compext}}" \
                        done < <(find %{buildroot}/usr/lib/debug/lib/modules -type f -name '*.ko*.debug')

%kernel_module_package


%description
%{summary}


%prep
%setup -T -b 0 -q -n kmod-qcom-scmi-%{srcrev}


%build
%make_build -C %{kernel_source default} M=$PWD modules


%install
%make_build -C %{kernel_source default} M=$PWD INSTALL_MOD_PATH=%{buildroot} INSTALL_MOD_DIR=extra DEPMOD=/usr/bin/true modules_install


%changelog
* Mon Feb 17 2025 Eric Chanudet <echanude@redhat.com> 5.14.0-569.517.2-2
- spec: upgrade to next kernel version

* Thu Feb 13 2025 Eric Chanudet <echanude@redhat.com> 5.14.0-563.511.2-2
- spec: compress modules
- spec: upgrade kmod to the next version

* Wed Jan 22 2025 Eric Chanudet <echanude@redhat.com> 5.14.0~549.498.1-1
- spec: initial packaging
